// RechenaufgabenTutor.h : Declaration of the CRechenaufgabenTutor

#pragma once
#include "resource.h"       // main symbols


// IRechenaufgabenTutor
[
	object,
	uuid("87706B27-F6EF-419E-A76C-ACAA2FCC6B6C"),
	dual,	helpstring("IRechenaufgabenTutor Interface"),
	pointer_default(unique)
]
__interface IRechenaufgabenTutor : IDispatch
{
	[id(1), helpstring("method NeueAufgabe")] HRESULT NeueAufgabe(void);
	[id(2), helpstring("method Richtig")] HRESULT Richtig(void);
	[id(3), helpstring("method Falsch")] HRESULT Falsch(void);
	[id(4), helpstring("method Bemerkung")] HRESULT Bemerkung([out] BSTR* Text);
};



// CRechenaufgabenTutor

[
	coclass,
	threading("apartment"),
	vi_progid("AufgabenTutor.RechenaufgabenTutor"),
	progid("AufgabenTutor.RechenaufgabenTutor.1"),
	version(1.0),
	uuid("4C6584C2-4228-40CF-9936-F05FA1CE9C03"),
	helpstring("RechenaufgabenTutor Class")
]
class ATL_NO_VTABLE CRechenaufgabenTutor : 
	public IRechenaufgabenTutor
{
public:
	CRechenaufgabenTutor()
		: n_aufgaben(0)
		, n_richtig(0)
		, n_falsch(0)
	{
	}


	DECLARE_PROTECT_FINAL_CONSTRUCT()

	HRESULT FinalConstruct()
	{
		return S_OK;
	}
	
	void FinalRelease() 
	{
	}

public:

	STDMETHOD(NeueAufgabe)(void);
	STDMETHOD(Richtig)(void);
	STDMETHOD(Falsch)(void);
	STDMETHOD(Bemerkung)(BSTR* Text);
private:
	int n_aufgaben;
	int n_richtig;
	int n_falsch;
};

